declare "user32",GetDesktopWindow(),int
declare "user32",GetTopWindow(hWnd:int),int

declare "user32",GetWindow(hWnd:int,uCmd:int),int
const GW_HWNDFIRST	=0
const GW_HWNDLAST	=1
const GW_HWNDNEXT	=2
const GW_HWNDPREV	=3
const GW_OWNER		=4
const GW_CHILD		=5


declare "user32",BeginDeferWindowPos(nNumWindows:int),int
declare "user32",DeferWindowPos(hWinPosInfo:int,hWnd:int,hWndInsertAfter:int,x:int,y:int,cx:int,cy:int,uFlags:int),int
declare "user32",EndDeferWindowPos(hWinPosInfo:int),int

declare "user32",UpdateWindow(hWnd:int),int


declare "user32",SetWindowPos(hWnd:int,hWndInsertAfter:int,X:int,Y:int,cx:int,cy:int,uFlags:int),int

const HWND_NOTOPMOST=-2
const HWND_TOPMOST	=-1
const HWND_TOP		=0
const HWND_BOTTOM	=1

const SWP_NOSIZE		=1
const SWP_NOMOVE		=2
const SWP_NOZORDER		=4
const SWP_NOREDRAW		=8
const SWP_NOACTIVATE	=16
const SWP_DRAWFRAME		=32
const SWP_FRAMECHANGED	=32
const SWP_SHOWWINDOW	=64
const SWP_HIDEWINDOW	=128
const SWP_NOCOPYBITS	=256
const SWP_NOOWNERZORDER	=512
const SWP_NOREPOSITION	=512
const SWP_NOSENDCHANGING=1024

declare "user32",SetParent(hWndChild:int,hWndNewParent:int),int

declare "user32",FindWindowA(lpClassName:pointer,lpWindowName:pointer),int
declare "user32",FindWindowExA(hwndParent:int,hwndChildAfter:int,lpszClass:pointer,lpszWindow:pointer),int

declare "user32",GetClassNameA(hWnd:int,lpClassName:string,nMaxCount:int),int

declare "user32",ClientToScreen(hWnd:int,lpPoint:POINT byref),int

declare "user32",GetSysColor(nIndex:int),int
'Put in the rest....

const COLOR_SCROLLBAR = 0
const COLOR_WINDOWTEXT=8
const COLOR_APPWORKSPACE=12
const COLOR_BTNFACE=15
const COLOR_3DSHADOW = 16 
const COLOR_3DHIGHLIGHT = 20
const COLOR_3DDKSHADOW = 21

declare "user32",SetForegroundWindow(hWnd:int),int

declare "user32",GetDlgItem(hDlg:int,nIDDlgItem:int),int

declare "user32",SendMessageA(w:int,mes:int,wp:int,lp:int),int
declare "user32",SendPntMessageA alias SendMessageA(w:int,mes:int,wp:int,lp:pointer),int

declare "user32",xSetCursor alias SetCursor(hCursor:int),int
declare "user32",GetCursorPos(lpPoint:point),int
declare "user32",ShowCursor(bShow:int),int
declare "user32",SetCursorPos(X:int,Y:int),int
declare "user32",SetCapture(hWnd:int),int
declare "user32",ReleaseCapture(),int
declare "user32",ClipCursor(lpRect:pointer /* WinRect or 0 */),int

declare "user32",ScreenToClient(Hwnd:int,lpPoint:pointer),int
declare "user32",WindowFromPoint(x:int,y:int),int
declare "user32",MapWindowPoints(hWndFrom:int,hWndTo:int,lpPoints:pointer,cPoints:uint),int

declare "user32",GetClientRect(hWnd:int,lpRect:winrect),int

declare "user32",GetClassLongA(hWnd:int,nIndex:int),int
declare "user32",SetClassLongA(hWnd:int,nIndex:int,dwNewLong:int),int
'Add the rest of 'em....
const GCL_HICON=-14
const GCL_HICONSM=-34

declare "user32",DestroyWindow(hWnd:int),int

declare "user32",CreateWindowExA(	dwExStyle:int,lpClassName:pointer,lpWindowName:pointer,dwStyle:int,_
									x:int,y:int,nWidth:int,nHeight:int,_
									nWndParent:int,hMenu:int,hInstance:int,lpParam:pointer),int

const WS_EX_LEFT					=0x0
const WS_EX_LTRREADING			=0x0
const WS_EX_RIGHTSCROLLBAR		=0x0
const WS_EX_DLGMODALFRAME		=0x1
const WS_EX_NOPARENTNOTIFY		=0x4
const WS_EX_TOPMOST				=0x8
const WS_EX_ACCEPTFILES			=0x10
const WS_EX_TRANSPARENT			=0x20
const WS_EX_MDICHILD				=0x40
const WS_EX_TOOLWINDOW			=0x80
const WS_EX_WINDOWEDGE			=0x100
const WS_EX_CLIENTEDGE			=0x200
const WS_EX_CONTEXTHELP			=0x400
const WS_EX_RIGHT					=0x1000
const WS_EX_RTLREADING			=0x2000
const WS_EX_LEFTSCROLLBAR		=0x4000
const WS_EX_OVERLAPPEDWINDOW	=WS_EX_CLIENTEDGE|WS_EX_WINDOWEDGE 
const WS_EX_PALETTEWINDOW		=WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST
const WS_EX_CONTROLPARENT		=0x10000
const WS_EX_STATICEDGE			=0x20000
const WS_EX_APPWINDOW			=0x40000
'2000+
const WS_EX_LAYERED				=0x80000
const WS_EX_NOINHERITLAYOUT	=0x00100000
const WS_EX_LAYOUTRTL     		=0x00400000
const WS_EX_NOACTIVATE			=0x08000000
'XP+
const WS_EX_COMPOSITED			=0x02000000

const WS_OVERLAPPED				=0x00000000
const WS_TILED						=0x00000000
const WS_MAXIMIZEBOX			=0x00010000
const WS_TABSTOP					=0x00010000
const WS_GROUP					=0x00020000
const WS_MINIMIZEBOX				=0x00020000
const WS_SIZEBOX					=0x00040000
const WS_THICKFRAME				=0x00040000
const WS_SYSMENU					=0x00080000
const WS_HSCROLL					=0x00100000
const WS_VSCROLL					=0x00200000
const WS_DLGFRAME				=0x00400000
const WS_BORDER					=0x00800000
const WS_CAPTION					=0x00c00000
const WS_OVERLAPPEDWINDOW		=0x00cf0000
const WS_TILEDWINDOW			=0x00cf0000
const WS_MAXIMIZE					=0x01000000
const WS_CLIPCHILDREN			=0x02000000
const WS_CLIPSIBLINGS			=0x04000000
const WS_DISABLED				=0x08000000
const WS_VISIBLE					=0x10000000
const WS_ICONIC					=0x20000000
const WS_MINIMIZE					=0x20000000
const WS_CHILD					=0x40000000
const WS_CHILDWINDOW			=0x40000000
const WS_POPUP					=0x80000000
const WS_POPUPWINDOW			=0x80880000

declare "user32",SetWindowLongA(hWnd:int,nIndex:int,dwNewLong:int),int
declare "user32",GetWindowLongA(hWnd:int,nIndex:int),int
const GWL_EXSTYLE	=-20
const GWL_STYLE		=-16
const GWL_WNDPROC=-4
const GWL_HINSTANCE=-6
const GWL_HWNDPARENT=-8
const GWL_ID=-12
const GWL_USERDATA=-21

const GWLP_HINSTANCE=-6
const GWLP_HWNDPARENT=-8
const GWLP_USERDATA=-21
const GWLP_ID=-12

const DWL_DLGPROC=4
const DWL_MSGRESULT=0
const DWL_USER=8

const DWLP_MSGRESULT=0

declare "user32",InvalidateRect(hWnd:int,lpRect:pointer,bErase:int),int
declare "user32",ValidateRect(hWnd:int,lpRect:pointer),int

declare "user32",SendDlgItemMessageA(hDlg:int,nIDDlgItem:int,Msg:int,wParam:int,lParam:int),int

declare "user32",InSendMessage(),int

declare "user32",RegisterWindowMessageA(lpString:string),int

const HWND_BROADCAST=0xffff

declare "user32",RegisterHotKey(hWnd:int,id:int,fsModifiers:int,vk:int),int
const MOD_ALT		=1
const MOD_CONTROL	=2
const MOD_SHIFT		=4
const MOD_WIN		=8

type CREATESTRUCT
	pointer lpCreateParams
	int hInstance
	int hMenu
	int hwndParent
	int cy
	int cx
	int y
	int x
	int style
	pointer lpszName
	pointer lpszClass
	int dwExStyle
endtype

declare "user32",FlashWindow(hWnd:int,bInvert:int),int

declare "user32",IsIconic(hWnd:int),int
declare "user32",IsZoomed(hWnd:int),int

declare "user32",xShowWindow alias ShowWindow(hWnd:int,nCmdShow:int),int

declare "user32",EnableWindow(hWnd:int,bEnable:int),int

'Internal Cursors...

const IDC_ARROW			=32512
const IDC_IBEAM			=32513
const IDC_WAIT				=32514
const IDC_CROSS			=32515
const IDC_UPARROW		=32516
const IDC_SIZENWSE		=32642
const IDC_SIZENESW		=32643
const IDC_SIZEWE			=32644
const IDC_SIZENS			=32645
const IDC_SIZEALL			=32646
const IDC_NO				=32648
'Next three for Win98 and up...
const IDC_HAND			=32649
const IDC_APPSTARTING	=32650
const IDC_HELP				=32651

const OBM_CLOSE  =         32754
const OBM_UPARROW  =       32753
const OBM_DNARROW   =      32752
const OBM_RGARROW   =      32751
const OBM_LFARROW   =      32750
const OBM_REDUCE    =      32749
const OBM_ZOOM      =      32748
const OBM_RESTORE   =      32747
const OBM_REDUCED   =      32746
const OBM_ZOOMD     =      32745
const OBM_RESTORED  =      32744
const OBM_UPARROWD  =      32743
const OBM_DNARROWD  =      32742
const OBM_RGARROWD  =      32741
const OBM_LFARROWD  =      32740
const OBM_MNARROW   =      32739
const OBM_COMBO     =      32738
const OBM_UPARROWI  =      32737
const OBM_DNARROWI  =      32736
const OBM_RGARROWI  =      32735
const OBM_LFARROWI  =      32734
const OBM_OLD_CLOSE =      32767
const OBM_SIZE      =      32766
const OBM_OLD_UPARROW  =   32765
const OBM_OLD_DNARROW  =   32764
const OBM_OLD_RGARROW  =   32763
const OBM_OLD_LFARROW  =   32762
const OBM_BTSIZE      =    32761
const OBM_CHECK       =    32760
const OBM_CHECKBOXES   =   32759
const OBM_BTNCORNERS   =   32758
const OBM_OLD_REDUCE   =   32757
const OBM_OLD_ZOOM     =   32756
const OBM_OLD_RESTORE   =  32755

const OIC_SAMPLE   =       32512
const OIC_HAND     =       32513
const OIC_QUES     =       32514
const OIC_BANG     =       32515
const OIC_NOTE     =       32516
const OIC_WINLOGO  =       32517
const OIC_WARNING  =       OIC_BANG
const OIC_ERROR    =       OIC_HAND
const OIC_INFORMATION  =   OIC_NOTE

'declare "user32",RegisterClassExA(lpwcx:WNDCLASSEX),int
'declare "user32",DefWindowProcA(hWnd:int,Msg:uint,wParam:int,lParam:int),int
'declare "user32",BeginPaint(hwnd:int,lpPaint:PAINTSTRUCT),int
'declare "user32",EndPaint(hwnd:int,lpPaint:PAINTSTRUCT),int

type PAINTSTRUCT
	int  hdc
	int fErase
	winrect rcPaint
	int fRestore
	int fIncUpdate
	char rgbReserved[32]
endtype

type WNDCLASSEX
	UINT cbSize
	UINT style
	uint lpfnWndProc
	int cbClsExtra
	int cbWndExtra
	int hInstance
	int hIcon
	int hCursor
	int hbrBackground
	pointer lpszMenuName
	pointer lpszClassName
	int hIconSm
endtype

const CS_VREDRAW				=0x0001
const CS_HREDRAW				=0x0002
const CS_DBLCLKS				=0x0008
const CS_OWNDC				=0x0020
const CS_CLASSDC				=0x0040
const CS_PARENTDC			=0x0080
const CS_NOCLOSE				=0x0200
const CS_SAVEBITS				=0x0800
const CS_BYTEALIGNCLIENT		=0x1000
const CS_BYTEALIGNWINDOW	=0x2000
const CS_GLOBALCLASS			=0x4000
const CS_DROPSHADOW		=0x00020000 :' Xp only


declare "user32",CreateCaret(hWnd:int,hBitmap:int,nWidth:int,nHeight:int),int
declare "user32",ShowCaret(hWnd:int),int
declare "user32",SetCaretPos(X:int,Y:int),int
declare "user32",DestroyCaret(),int
declare "user32",HideCaret(hWnd:int),int
declare "user32",GetCaretPos(lpPoint:point),int

declare "user32",EnumWindows(lpEnumFunc:int,lParam:int),int
declare "user32",GetWindowTextA(hWnd:int,lpString:string,nMaxCount:int),int

declare "user32",IsWindowVisible(hWnd:int),int
const LWA_COLORKEY=0x00000001
const LWA_ALPHA	=0x00000002
const ULW_COLORKEY=0x00000001
const ULW_ALPHA	=0x00000002
const ULW_OPAQUE	=0x00000004

declare "user32",RedrawWindow(hWnd:int,lprcUpdate:pointer,hrgnUpdate:int,flags:int),int

const RDW_INVALIDATE		=0x0001
const RDW_INTERNALPAINT	=0x0002
const RDW_ERASE			=0x0004
const RDW_VALIDATE			=0x0008
const RDW_NOINTERNALPAINT	=0x0010
const RDW_NOERASE			=0x0020
const RDW_NOCHILDREN		=0x0040
const RDW_ALLCHILDREN		=0x0080
const RDW_UPDATENOW		=0x0100
const RDW_ERASENOW		=0x0200
const RDW_FRAME			=0x0400
const RDW_NOFRAME			=0x0800

declare "user32",GetPropA(hWnd:uint,lpString:pointer),uint
declare "user32",SetPropA(hWnd:uint,lpString:pointer,hData:int),int
declare "user32",RemovePropA(hWnd:uint,lpString:pointer),int

declare "user32",SetTimer(hWnd:int,nIDEvent:int,uElapse:uint,lpTimerFunc:uint),int
declare "user32",KillTimer(hWnd:int,uIDEvent:int),int

declare "user32",LoadCursorA(hInstance:int,lpCursorName:pointer),int

declare "user32",GetDlgCtrlID(hwndCtl:int),int

declare "user32",GetActiveWindow(),int
declare "user32",GetForegroundWindow(),int

declare "user32",CallWindowProcA(lpPrevWndFunc:int,hWnd:int,Msg:int,wParam:int,lParam:int),int

declare "comctl32",ShowHideMenuCtl(hWnd:int,uFlags:int,lpInfo:pointer),int
declare "comctl32",GetEffectiveClientRect(hWnd:int,lprc:winrect,lpInfo:pointer)

declare "user32",LockWindowUpdate(hWndLock:int),int

'For Windows 98 and Up
declare "user32",AnimateWindow(hwnd:int,dwTime:int,dwFlags:int),int
const AW_HOR_POSITIVE	=0x00000001
const AW_HOR_NEGATIVE	=0x00000002
const AW_VER_POSITIVE	=0x00000004
const AW_VER_NEGATIVE	=0x00000008
const AW_CENTER			=0x00000010
const AW_HIDE				=0x00010000
const AW_ACTIVATE			=0x00020000
const AW_SLIDE				=0x00040000
const AW_BLEND			=0x00080000

declare "user32",ChildWindowFromPoint(hWndParent:int,Point:point),int
declare "user32",ChildWindowFromPointEx(hwndParent:int,pt:point,uFlags:uint),int
const CWP_ALL					=0x0000
const CWP_SKIPINVISIBLE		=0x0001
const CWP_SKIPDISABLED		=0x0002
const CWP_SKIPTRANSPARENT	=0x0004

declare "user32",DrawEdge(hdc:int,qrc:winrect,edge:int,grfFlags:int),int

const BDR_RAISEDOUTER				=0x0001
const BDR_SUNKENOUTER				=0x0002
const BDR_RAISEDINNER				=0x0004
const BDR_SUNKENINNER				=0x0008
const BDR_OUTER						=(BDR_RAISEDOUTER | BDR_SUNKENOUTER)
const BDR_INNER						=(BDR_RAISEDINNER | BDR_SUNKENINNER)
const BDR_RAISED						=(BDR_RAISEDOUTER | BDR_RAISEDINNER)
const BDR_SUNKEN						=(BDR_SUNKENOUTER | BDR_SUNKENINNER)
const EDGE_RAISED						=(BDR_RAISEDOUTER | BDR_RAISEDINNER)
const EDGE_SUNKEN					=(BDR_SUNKENOUTER | BDR_SUNKENINNER)
const EDGE_ETCHED					=(BDR_SUNKENOUTER | BDR_RAISEDINNER)
const EDGE_BUMP						=(BDR_RAISEDOUTER | BDR_SUNKENINNER)
const BF_LEFT							=0x0001
const BF_TOP							=0x0002
const BF_RIGHT							=0x0004
const BF_BOTTOM						=0x0008
const BF_TOPLEFT						=(BF_TOP | BF_LEFT)
const BF_TOPRIGHT						=(BF_TOP | BF_RIGHT)
const BF_BOTTOMLEFT					=(BF_BOTTOM | BF_LEFT)
const BF_BOTTOMRIGHT					=(BF_BOTTOM | BF_RIGHT)
const BF_RECT							=(BF_LEFT | BF_TOP | BF_RIGHT | BF_BOTTOM)
const BF_DIAGONAL						=0x0010
const BF_DIAGONAL_ENDTOPRIGHT		=(BF_DIAGONAL | BF_TOP | BF_RIGHT)
const BF_DIAGONAL_ENDTOPLEFT		=(BF_DIAGONAL | BF_TOP | BF_LEFT)
const BF_DIAGONAL_ENDBOTTOMLEFT	=(BF_DIAGONAL | BF_BOTTOM | BF_LEFT)
const BF_DIAGONAL_ENDBOTTOMRIGHT	=(BF_DIAGONAL | BF_BOTTOM | BF_RIGHT)
const BF_MIDDLE						=0x0800
const BF_SOFT							=0x1000
const BF_ADJUST						=0x2000
const BF_FLAT							=0x4000
const BF_MONO							=0x8000

declare "user32",DrawFrameControl(hdc:int,lprc:winrect,uType:uint,uState:uint),int
const DFC_CAPTION             =1
const DFC_MENU                =2
const DFC_SCROLL              =3
const DFC_BUTTON              =4
'Next one for 98 and up only...
const DFC_POPUPMENU           =5
const DFCS_CAPTIONCLOSE       =0x0000
const DFCS_CAPTIONMIN         =0x0001
const DFCS_CAPTIONMAX         =0x0002
const DFCS_CAPTIONRESTORE     =0x0003
const DFCS_CAPTIONHELP        =0x0004
const DFCS_MENUARROW          =0x0000
const DFCS_MENUCHECK          =0x0001
const DFCS_MENUBULLET         =0x0002
const DFCS_MENUARROWRIGHT     =0x0004
const DFCS_SCROLLUP           =0x0000
const DFCS_SCROLLDOWN         =0x0001
const DFCS_SCROLLLEFT         =0x0002
const DFCS_SCROLLRIGHT        =0x0003
const DFCS_SCROLLCOMBOBOX     =0x0005
const DFCS_SCROLLSIZEGRIP     =0x0008
const DFCS_SCROLLSIZEGRIPRIGHT =0x0010
const DFCS_BUTTONCHECK        =0x0000
const DFCS_BUTTONRADIOIMAGE   =0x0001
const DFCS_BUTTONRADIOMASK    =0x0002
const DFCS_BUTTONRADIO        =0x0004
const DFCS_BUTTON3STATE       =0x0008
const DFCS_BUTTONPUSH         =0x0010
const DFCS_INACTIVE           =0x0100
const DFCS_PUSHED             =0x0200
const DFCS_CHECKED            =0x0400
const DFCS_ADJUSTRECT         =0x2000
const DFCS_FLAT               =0x4000
const DFCS_MONO               =0x8000
'98 and up
const DFCS_TRANSPARENT        =0x0800
const DFCS_HOT                =0x1000

declare "user32",SetActiveWindow(hWnd:int),int
declare "user32",GetParent(hwnd:int),int
